import junit.framework.TestCase;
import java.awt.*;


public class Frog_Test extends TestCase {

  public void test_frog_states() {
    Frog frog = new Frog(); // Frog starts off as an egg.
    assertEquals("egg color", Color.PINK, frog.getColor());
    
    frog.holdBelowWater();  // No problem. Eggs live in the water.
    assertEquals("egg color", Color.PINK, frog.getColor());
    
    frog.holdAboveWater();  // Big problem.  Frog dies.
    assertEquals("Dead color", Color.BLACK, frog.getColor());
    
    frog.holdBelowWater();  // No problem. Dead is dead.
    assertEquals("Dead color", Color.BLACK, frog.getColor());
    
    frog.holdAboveWater();  // No problem. Dead is dead.
    assertEquals("Dead color", Color.BLACK, frog.getColor());

    frog.wait1Month();  // No change. Dead is dead.
    assertEquals("Dead color", Color.BLACK, frog.getColor());

    frog = new Frog();  // Start over with new frog egg.
    frog.wait1Month();  // Egg hatches into tadpole.
    assertEquals("tadpole color", Color.GRAY, frog.getColor());
    
    frog.holdBelowWater();  // No problem. Tadpoles live in the water.
    assertEquals("tadpole color", Color.GRAY, frog.getColor());
    
    frog.holdAboveWater();  // Big problem.  Frog dies.
    assertEquals("Dead color", Color.BLACK, frog.getColor());
    
    frog = new Frog();  // Start over with new frog egg.
    frog.wait1Month();  // Egg hatches into tadpole.
    frog.wait1Month();  // Tadpole becomes a frog.
    assertEquals("frog color", Color.GREEN, frog.getColor());
    
    frog.wait1Month();  // Frogs stay frogs for many months.
    assertEquals("frog color", Color.GREEN, frog.getColor());
    
    frog.holdAboveWater();  // No problem. Frogs live out of the water.
    assertEquals("frog color", Color.GREEN, frog.getColor());
    
    frog.holdBelowWater();  // Big problem.  Air-breathing frog dies.
    assertEquals("Dead color", Color.BLACK, frog.getColor());
    
  }
  
}
