package genList;

/**
 * Represents a node in the generalized list
 */
public interface INode {
  /**
   * Method to accept a visitor to perform an algorithm on 
   * this node.
   * @param algo The algorithm to execute.
   * @param Vararg input parameters, passed unmodified to the visitor.
   * @return The return value of the algorithm.
   */
  public Object execute(INodeAlgo algo, Object... inp);
}