package genList;

/**
 * Represents an algorithm on a node of a generalized list.
 */
public interface INodeAlgo {
  /**
   * Called by an IDataNode node.
   * @param host  The data node itself
   * @pram inp Vararg input parameters for the algorithm
   * @return The result of the algorithm.
   */
  public Object dataCase(IDataNode host, Object[] inp);
  /**
   * Called by an IListNode node.
   * @param host  The list node itself
   * @pram inp Vararg input parameters for the algorithm
   * @return The result of the algorithm.
   */
  public Object listCase(IListNode host, Object[] inp);
}