package genList;
import listFW.*;

/**
 * Represents a factory to construct INode instances.
 */
public interface INodeFactory {
  /**
   * Make a data node given a data value.
   * @param data The data to be held at this node.
   * @return A new IDataNode instance.
   */
  public IDataNode makeDataNode(Object data);
  
  /**
   * Make a list node given an IList instance.
   * @param list The list to be held at this node.
   * @return A new IListNode instance.
   */
  public IListNode makeListNode(IList list);
}