package listFW.visitor;
import listFW.*;
import genList.*;

/**
 * Algorithm to count the data elements of a generalized list
 * Returns the total number of data elements in the list. 
 * The input parameter is not used.
 */
public class CountGenList implements IListAlgo {
  /**
   * Singleton pattern
   */
  public static final CountGenList Singleton = new CountGenList();
  
  private CountGenList() {}
  
  /**
   * The generalized list is empty.  
   * There are no data elements in this list.
   */
  public Object emptyCase(IMTList host, Object... nu) {
    // STUDENT TO COMPLETE
    return 0;
  }
  
  /**
   * The generalized list is non-empty.
   * First may or may not be a data element and thus contains an unknown 
   * total number of data elements.  Not that if first is list node, 
   * the contained list may or may not be empty.
   * Also, there are an unknown number of data elements in this list's rest.
   * The total number of data elements is the total number of data elements 
   * in first plus the the total number of data elements in rest.
   */
  public Object nonEmptyCase(final INEList host, Object... nu) {
    // STUDENT TO COMPLETE
    // Reminder: both getFirst() and execute() return type Object!
    
    // The total count is the count of first plus the count of rest.
    return (Integer)((INode)host.getFirst()).execute(new INodeAlgo(){
      /**
       * The count of a data node is 1
       */
      public Object dataCase(IDataNode h, Object... nu) {
        return 1;
      }
      
      /**
       * The count of a list node is the count of the contained list
       */
      public Object listCase(IListNode h, Object... nu) {
        return h.getList().execute(CountGenList.this);
      }
    }) + (Integer) host.getRest().execute(this);
  }
}

