package lrs.visitor.test;
import lrs.*;
import lrs.visitor.*;
import junit.framework.TestCase;

public class SmoothingAlgo_Test extends TestCase {

  public void test_smooth() {
    IAlgo algo = SmoothingAlgo.Singleton;
    
    LRStruct list = new LRStruct();
    int nPts = 2; // 2 element smoothing window
    list.insertFront(2.0).insertFront(2.5).insertFront(3.0).insertFront(1.0).insertFront(1.5).insertFront(2.25);
    assertEquals("(2.25 1.5 1.0 3.0 2.5 2.0)","(2.25 1.875 1.25 2.0 2.75 2.25)",list.execute(algo, nPts).toString());

    list = new LRStruct();
    nPts = 4; // 4 element smoothing window    
    list.insertFront(2.0).insertFront(2.5).insertFront(3.0).insertFront(1.0).insertFront(1.5).insertFront(2.25);  
    assertEquals("(2.25 1.5 1.0 3.0 2.5 2.0)","(2.25 1.875 1.5833333333333333 1.9375 2.0 2.125)",list.execute(algo, nPts).toString());

    // More extensive testing:
    nPts = 4;
    list = new LRStruct();
    assertEquals("empty list","()", list.execute(algo, nPts).toString());
    list.insertFront(1.0);
    assertEquals("(1)","(1.0)", list.execute(algo, nPts).toString());
    list.insertFront(2.0);
    assertEquals("(2 1)","(2.0 1.5)", list.execute(algo, nPts).toString());
    list.insertFront(2.5);
    assertEquals("(2.5 2 1.5)","(2.5 2.25 2.0)", list.execute(algo, nPts).toString());
    
    list.insertFront(1.25);
    assertEquals("(1.25 2.5 2.25 2.0)","(1.25 1.875 2.0 2.0)", list.execute(algo, nPts).toString());

    list.insertFront(3.25);
    assertEquals("(3.25 1.25 1.875 2.0 2.0)","(3.25 2.25 2.125 2.09375 1.78125)", list.execute(algo, nPts).toString());
    
    list.insertFront(4.25);
    assertEquals("(4.25 3.25 2.25 2.125 2.09375 1.78125)","(4.25 3.75 3.25 2.96875 2.4296875 2.0625)", list.execute(algo, nPts).toString());

    nPts = 2;  // Change to a 2 element smoothing window
    assertEquals("(4.25 3.75 3.25 2.96875 2.4296875 2.0625)","(4.25 4.0 3.5 3.109375 2.69921875 2.24609375)", list.execute(algo, nPts).toString());
  }
  
}
