package lrs.visitor.test;
import lrs.*;
import lrs.visitor.*;
import java.util.*;
import junit.framework.TestCase;


public class Test_Sort extends TestCase {

  /**
   * returns a negative value if x < y
   * where x and y are Comparables (e.g. Integers).
   * When used with the SelectSort algo, should
   * produce a list sorted in ascending order.
   */
  Comparator comp = new Comparator() {
    public int compare(Object x, Object y) {
      return ((Comparable)x).compareTo(y);
    }
  };
  
  /**
   * Performs the opposite comparison to comp above.
   * When used with the SelectSort algo, should
   * produce a list sorted in descending order.
   */
  Comparator comp2 = new Comparator() {
    public int compare(Object x, Object y) {
      return ((Comparable)y).compareTo(x);
    }
  };
  
  public void test_sort() {
    
    IAlgo sort = SelectSort.Singleton;
    
    LRStruct lrs = new LRStruct();
    assertEquals("Empty list", "()", lrs.execute(sort, comp).toString());
    
    lrs.insertFront(42);
    assertEquals("(42)", "(42)", lrs.execute(sort, comp).toString());
    
    lrs.insertFront(50);
    assertEquals("(50 42)", "(42 50)", lrs.execute(sort, comp).toString());  
    
    lrs.insertFront(45);
    assertEquals("(45, 42, 50)", "(42 45 50)", lrs.execute(sort, comp).toString());

    lrs.insertFront(47);
    assertEquals("(47 42 45 50)", "(50 47 45 42)", lrs.execute(sort, comp2).toString());
  
  }
  
  
  
}
